diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/fdbet-ff-mac-scheduler.h ns-3.38/src/lte/model/fdbet-ff-mac-scheduler.h
--- ns-3.37/src/lte/model/fdbet-ff-mac-scheduler.h	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/fdbet-ff-mac-scheduler.h	2023-03-16 20:54:23.768869000 -0700
@@ -290,9 +290,9 @@
      * \brief Return the availability of free process for the RNTI specified
      *
      * \param rnti the RNTI of the UE to be updated
-     * \return the process id  value
+     * \return the availability
      */
-    uint8_t HarqProcessAvailability(uint16_t rnti);
+    bool HarqProcessAvailability(uint16_t rnti);
 
     /**
      * \brief Refresh HARQ processes according to the timers
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/fdmt-ff-mac-scheduler.cc ns-3.38/src/lte/model/fdmt-ff-mac-scheduler.cc
--- ns-3.37/src/lte/model/fdmt-ff-mac-scheduler.cc	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/fdmt-ff-mac-scheduler.cc	2023-03-16 20:54:23.768869000 -0700
@@ -37,11 +37,11 @@
 
 /// FdMtType0AllocationRbg size array
 static const int FdMtType0AllocationRbg[4] = {
-    10, // RGB size 1
-    26, // RGB size 2
-    63, // RGB size 3
-    110 // RGB size 4
-};      // see table 7.1.6.1-1 of 36.213
+    10,  // RGB size 1
+    26,  // RGB size 2
+    63,  // RGB size 3
+    110, // RGB size 4
+};       // see table 7.1.6.1-1 of 36.213
 
 NS_OBJECT_ENSURE_REGISTERED(FdMtFfMacScheduler);
 
@@ -358,7 +358,7 @@
     return (lcActive);
 }
 
-uint8_t
+bool
 FdMtFfMacScheduler::HarqProcessAvailability(uint16_t rnti)
 {
     NS_LOG_FUNCTION(this << rnti);
@@ -587,9 +587,9 @@
     // Process DL HARQ feedback
     RefreshHarqProcesses();
     // retrieve past HARQ retx buffered
-    if (m_dlInfoListBuffered.size() > 0)
+    if (!m_dlInfoListBuffered.empty())
     {
-        if (params.m_dlInfoList.size() > 0)
+        if (!params.m_dlInfoList.empty())
         {
             NS_LOG_INFO(this << " Received DL-HARQ feedback");
             m_dlInfoListBuffered.insert(m_dlInfoListBuffered.end(),
@@ -599,7 +599,7 @@
     }
     else
     {
-        if (params.m_dlInfoList.size() > 0)
+        if (!params.m_dlInfoList.empty())
         {
             m_dlInfoListBuffered = params.m_dlInfoList;
         }
@@ -827,7 +827,7 @@
                     }
                 }
 
-                if (rlcPduListPerLc.size() > 0)
+                if (!rlcPduListPerLc.empty())
                 {
                     newEl.m_rlcPduList.push_back(rlcPduListPerLc);
                 }
@@ -877,7 +877,7 @@
     if (rbgAllocatedNum == rbgNum)
     {
         // all the RBGs are already allocated -> exit
-        if ((ret.m_buildDataList.size() > 0) || (ret.m_buildRarList.size() > 0))
+        if (!ret.m_buildDataList.empty() || !ret.m_buildRarList.empty())
         {
             m_schedSapUser->SchedDlConfigInd(ret);
         }
@@ -900,11 +900,11 @@
                     // UE already allocated for HARQ or without HARQ process available -> drop it
                     if (itRnti != rntiAllocated.end())
                     {
-                        NS_LOG_DEBUG(this << " RNTI discared for HARQ tx" << (uint16_t)(*it));
+                        NS_LOG_DEBUG(this << " RNTI discarded for HARQ tx" << (uint16_t)(*it));
                     }
                     if (!HarqProcessAvailability((*it)))
                     {
-                        NS_LOG_DEBUG(this << " RNTI discared for HARQ id" << (uint16_t)(*it));
+                        NS_LOG_DEBUG(this << " RNTI discarded for HARQ id" << (uint16_t)(*it));
                     }
                     continue;
                 }
@@ -1420,7 +1420,7 @@
 
     if (nflows == 0)
     {
-        if (ret.m_dciList.size() > 0)
+        if (!ret.m_dciList.empty())
         {
             m_allocationMaps.insert(
                 std::pair<uint16_t, std::vector<uint16_t>>(params.m_sfnSf, rbgAllocationMap));
@@ -1465,7 +1465,8 @@
         if ((itRnti != rntiAllocated.end()) || ((*it).second == 0))
         {
             // UE already allocated for UL-HARQ -> skip it
-            NS_LOG_DEBUG(this << " UE already allocated in HARQ -> discared, RNTI " << (*it).first);
+            NS_LOG_DEBUG(this << " UE already allocated in HARQ -> discarded, RNTI "
+                              << (*it).first);
             it++;
             if (it == m_ceBsrRxed.end())
             {
@@ -1536,7 +1537,7 @@
         {
             // unable to allocate new resource: finish scheduling
             m_nextRntiUl = (*it).first;
-            if (ret.m_dciList.size() > 0)
+            if (!ret.m_dciList.empty())
             {
                 m_schedSapUser->SchedUlConfigInd(ret);
             }
@@ -1555,7 +1556,7 @@
         else
         {
             // take the lowest CQI value (worst RB)
-            NS_ABORT_MSG_IF((*itCqi).second.size() == 0,
+            NS_ABORT_MSG_IF((*itCqi).second.empty(),
                             "CQI of RNTI = " << (*it).first << " has expired");
             double minSinr = (*itCqi).second.at(uldci.m_rbStart);
             if (minSinr == NO_SINR)
@@ -1810,7 +1811,7 @@
     case UlCqi_s::SRS: {
         // get the RNTI from vendor specific parameters
         uint16_t rnti = 0;
-        NS_ASSERT(params.m_vendorSpecificList.size() > 0);
+        NS_ASSERT(!params.m_vendorSpecificList.empty());
         for (std::size_t i = 0; i < params.m_vendorSpecificList.size(); i++)
         {
             if (params.m_vendorSpecificList.at(i).m_type == SRS_CQI_RNTI_VSP)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/fdmt-ff-mac-scheduler.h ns-3.38/src/lte/model/fdmt-ff-mac-scheduler.h
--- ns-3.37/src/lte/model/fdmt-ff-mac-scheduler.h	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/fdmt-ff-mac-scheduler.h	2023-03-16 20:54:23.768869000 -0700
@@ -269,7 +269,7 @@
      */
     void UpdateDlRlcBufferInfo(uint16_t rnti, uint8_t lcid, uint16_t size);
     /**
-     * Update UL RLC b uffer info function
+     * Update UL RLC buffer info function
      * \param rnti the RNTI
      * \param size the size
      */
@@ -287,9 +287,9 @@
      * \brief Return the availability of free process for the RNTI specified
      *
      * \param rnti the RNTI of the UE to be updated
-     * \return the process id  value
+     * \return the availability
      */
-    uint8_t HarqProcessAvailability(uint16_t rnti);
+    bool HarqProcessAvailability(uint16_t rnti);
 
     /**
      * \brief Refresh HARQ processes according to the timers
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/fdtbfq-ff-mac-scheduler.cc ns-3.38/src/lte/model/fdtbfq-ff-mac-scheduler.cc
--- ns-3.37/src/lte/model/fdtbfq-ff-mac-scheduler.cc	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/fdtbfq-ff-mac-scheduler.cc	2023-03-16 20:54:23.768869000 -0700
@@ -38,11 +38,11 @@
 
 /// FdTbfqType0AllocationRbg value array
 static const int FdTbfqType0AllocationRbg[4] = {
-    10, // RGB size 1
-    26, // RGB size 2
-    63, // RGB size 3
-    110 // RGB size 4
-};      // see table 7.1.6.1-1 of 36.213
+    10,  // RGB size 1
+    26,  // RGB size 2
+    63,  // RGB size 3
+    110, // RGB size 4
+};       // see table 7.1.6.1-1 of 36.213
 
 NS_OBJECT_ENSURE_REGISTERED(FdTbfqFfMacScheduler);
 
@@ -423,7 +423,7 @@
     return (lcActive);
 }
 
-uint8_t
+bool
 FdTbfqFfMacScheduler::HarqProcessAvailability(uint16_t rnti)
 {
     NS_LOG_FUNCTION(this << rnti);
@@ -700,9 +700,9 @@
     // Process DL HARQ feedback
     RefreshHarqProcesses();
     // retrieve past HARQ retx buffered
-    if (m_dlInfoListBuffered.size() > 0)
+    if (!m_dlInfoListBuffered.empty())
     {
-        if (params.m_dlInfoList.size() > 0)
+        if (!params.m_dlInfoList.empty())
         {
             NS_LOG_INFO(this << " Received DL-HARQ feedback");
             m_dlInfoListBuffered.insert(m_dlInfoListBuffered.end(),
@@ -712,7 +712,7 @@
     }
     else
     {
-        if (params.m_dlInfoList.size() > 0)
+        if (!params.m_dlInfoList.empty())
         {
             m_dlInfoListBuffered = params.m_dlInfoList;
         }
@@ -940,7 +940,7 @@
                     }
                 }
 
-                if (rlcPduListPerLc.size() > 0)
+                if (!rlcPduListPerLc.empty())
                 {
                     newEl.m_rlcPduList.push_back(rlcPduListPerLc);
                 }
@@ -990,7 +990,7 @@
     if (rbgAllocatedNum == rbgNum)
     {
         // all the RBGs are already allocated -> exit
-        if ((ret.m_buildDataList.size() > 0) || (ret.m_buildRarList.size() > 0))
+        if (!ret.m_buildDataList.empty() || !ret.m_buildRarList.empty())
         {
             m_schedSapUser->SchedDlConfigInd(ret);
         }
@@ -1036,11 +1036,11 @@
                 // UE already allocated for HARQ or without HARQ process available -> drop it
                 if (itRnti != rntiAllocated.end())
                 {
-                    NS_LOG_DEBUG(this << " RNTI discared for HARQ tx" << (uint16_t)(*it).first);
+                    NS_LOG_DEBUG(this << " RNTI discarded for HARQ tx" << (uint16_t)(*it).first);
                 }
                 if (!HarqProcessAvailability((*it).first))
                 {
-                    NS_LOG_DEBUG(this << " RNTI discared for HARQ id" << (uint16_t)(*it).first);
+                    NS_LOG_DEBUG(this << " RNTI discarded for HARQ id" << (uint16_t)(*it).first);
                 }
                 continue;
             }
@@ -1132,7 +1132,7 @@
         }
         budget = budget + (*itMax).second.tokenPoolSize;
 
-        // calculate how much bytes this UE actally need
+        // calculate how much bytes this UE actually need
         if (budget == 0)
         {
             // there are no tokens for this UE
@@ -1368,7 +1368,7 @@
             rbgMap.at(rbgIndex) = false; // unmark this RBG
             // If all the RBGs are removed from the allocation
             // of this RNTI, we remove the UE from the allocation map
-            if ((*itMap).second.size() == 0)
+            if ((*itMap).second.empty())
             {
                 itMap = allocationMap.erase(itMap);
             }
@@ -1837,7 +1837,7 @@
 
     if (nflows == 0)
     {
-        if (ret.m_dciList.size() > 0)
+        if (!ret.m_dciList.empty())
         {
             m_allocationMaps.insert(
                 std::pair<uint16_t, std::vector<uint16_t>>(params.m_sfnSf, rbgAllocationMap));
@@ -1886,7 +1886,8 @@
         if ((itRnti != rntiAllocated.end()) || ((*it).second == 0))
         {
             // UE already allocated for UL-HARQ -> skip it
-            NS_LOG_DEBUG(this << " UE already allocated in HARQ -> discared, RNTI " << (*it).first);
+            NS_LOG_DEBUG(this << " UE already allocated in HARQ -> discarded, RNTI "
+                              << (*it).first);
             it++;
             if (it == m_ceBsrRxed.end())
             {
@@ -1984,7 +1985,7 @@
         else
         {
             // take the lowest CQI value (worst RB)
-            NS_ABORT_MSG_IF((*itCqi).second.size() == 0,
+            NS_ABORT_MSG_IF((*itCqi).second.empty(),
                             "CQI of RNTI = " << (*it).first << " has expired");
             double minSinr = (*itCqi).second.at(uldci.m_rbStart);
             if (minSinr == NO_SINR)
@@ -2239,7 +2240,7 @@
     case UlCqi_s::SRS: {
         // get the RNTI from vendor specific parameters
         uint16_t rnti = 0;
-        NS_ASSERT(params.m_vendorSpecificList.size() > 0);
+        NS_ASSERT(!params.m_vendorSpecificList.empty());
         for (std::size_t i = 0; i < params.m_vendorSpecificList.size(); i++)
         {
             if (params.m_vendorSpecificList.at(i).m_type == SRS_CQI_RNTI_VSP)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/fdtbfq-ff-mac-scheduler.h ns-3.38/src/lte/model/fdtbfq-ff-mac-scheduler.h
--- ns-3.37/src/lte/model/fdtbfq-ff-mac-scheduler.h	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/fdtbfq-ff-mac-scheduler.h	2023-03-16 20:54:23.768869000 -0700
@@ -328,9 +328,9 @@
      * \brief Return the availability of free process for the RNTI specified
      *
      * \param rnti the RNTI of the UE to be updated
-     * \return the process id  value
+     * \return the availability
      */
-    uint8_t HarqProcessAvailability(uint16_t rnti);
+    bool HarqProcessAvailability(uint16_t rnti);
 
     /**
      * \brief Refresh HARQ processes according to the timers
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/ff-mac-common.h ns-3.38/src/lte/model/ff-mac-common.h
--- ns-3.37/src/lte/model/ff-mac-common.h	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/ff-mac-common.h	2023-03-16 20:54:23.768869000 -0700
@@ -182,7 +182,7 @@
 };
 
 /**
- * \brief See section 4.3.3 vendorSpecifiListElement
+ * \brief See section 4.3.3 vendorSpecificListElement
  * \struct VendorSpecificListElement_s
  */
 struct VendorSpecificListElement_s
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/ff-mac-csched-sap.h ns-3.38/src/lte/model/ff-mac-csched-sap.h
--- ns-3.37/src/lte/model/ff-mac-csched-sap.h	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/ff-mac-csched-sap.h	2023-03-16 20:54:23.768869000 -0700
@@ -470,6 +470,9 @@
      */
     MemberCschedSapProvider(C* scheduler);
 
+    // Delete default constructor to avoid misuse
+    MemberCschedSapProvider() = delete;
+
     // inherited from FfMacCschedSapProvider
     void CschedCellConfigReq(const struct CschedCellConfigReqParameters& params) override;
     void CschedUeConfigReq(const struct CschedUeConfigReqParameters& params) override;
@@ -478,16 +481,10 @@
     void CschedUeReleaseReq(const struct CschedUeReleaseReqParameters& params) override;
 
   private:
-    MemberCschedSapProvider();
     C* m_scheduler; ///< scheduler class
 };
 
 template <class C>
-MemberCschedSapProvider<C>::MemberCschedSapProvider()
-{
-}
-
-template <class C>
 MemberCschedSapProvider<C>::MemberCschedSapProvider(C* scheduler)
     : m_scheduler(scheduler)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/ff-mac-sched-sap.h ns-3.38/src/lte/model/ff-mac-sched-sap.h
--- ns-3.37/src/lte/model/ff-mac-sched-sap.h	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/ff-mac-sched-sap.h	2023-03-16 20:54:23.772869000 -0700
@@ -360,6 +360,9 @@
      */
     MemberSchedSapProvider(C* scheduler);
 
+    // Delete default constructor to avoid misuse
+    MemberSchedSapProvider() = delete;
+
     // inherited from FfMacSchedSapProvider
     void SchedDlRlcBufferReq(const struct SchedDlRlcBufferReqParameters& params) override;
     void SchedDlPagingBufferReq(const struct SchedDlPagingBufferReqParameters& params) override;
@@ -375,16 +378,10 @@
     void SchedUlCqiInfoReq(const struct SchedUlCqiInfoReqParameters& params) override;
 
   private:
-    MemberSchedSapProvider();
     C* m_scheduler; ///< the scheduler class
 };
 
 template <class C>
-MemberSchedSapProvider<C>::MemberSchedSapProvider()
-{
-}
-
-template <class C>
 MemberSchedSapProvider<C>::MemberSchedSapProvider(C* scheduler)
     : m_scheduler(scheduler)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/lte-amc.cc ns-3.38/src/lte/model/lte-amc.cc
--- ns-3.37/src/lte/model/lte-amc.cc	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/lte-amc.cc	2023-03-16 20:54:23.772869000 -0700
@@ -44,22 +44,24 @@
  * file `TBS_support.xls` tab "MCS Table" (rounded to 2 decimal digits).
  * The index of the vector (range 0-15) identifies the CQI value.
  */
-static const double SpectralEfficiencyForCqi[16] = {0.0, // out of range
-                                                    0.15,
-                                                    0.23,
-                                                    0.38,
-                                                    0.6,
-                                                    0.88,
-                                                    1.18,
-                                                    1.48,
-                                                    1.91,
-                                                    2.41,
-                                                    2.73,
-                                                    3.32,
-                                                    3.9,
-                                                    4.52,
-                                                    5.12,
-                                                    5.55};
+static const double SpectralEfficiencyForCqi[16] = {
+    0.0, // out of range
+    0.15,
+    0.23,
+    0.38,
+    0.6,
+    0.88,
+    1.18,
+    1.48,
+    1.91,
+    2.41,
+    2.73,
+    3.32,
+    3.9,
+    4.52,
+    5.12,
+    5.55,
+};
 
 #if 0 // currently unused
 /**
@@ -91,23 +93,28 @@
  */
 static const double SpectralEfficiencyForMcs[32] = {
     0.15, 0.19, 0.23, 0.31, 0.38, 0.49, 0.6, 0.74, 0.88, 1.03, 1.18, 1.33, 1.48, 1.7, 1.91, 2.16,
-    2.41, 2.57, 2.73, 3.03, 3.32, 3.61, 3.9, 4.21, 4.52, 4.82, 5.12, 5.33, 5.55, 0,   0,    0};
+    2.41, 2.57, 2.73, 3.03, 3.32, 3.61, 3.9, 4.21, 4.52, 4.82, 5.12, 5.33, 5.55, 0,   0,    0,
+};
 
 /**
  * Table of MCS index (IMCS) and its TBS index (ITBS). Taken from 3GPP TS
  * 36.213 v8.8.0 Table 7.1.7.1-1: _Modulation and TBS index table for PDSCH_.
  * The index of the vector (range 0-28) identifies the MCS index.
  */
-static const int McsToItbsDl[29] = {0,  1,  2,  3,  4,  5,  6,  7,  8,  9,  9,  10, 11, 12, 13,
-                                    14, 15, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26};
+static const int McsToItbsDl[29] = {
+    0,  1,  2,  3,  4,  5,  6,  7,  8,  9,  9,  10, 11, 12, 13,
+    14, 15, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26,
+};
 
 /**
  * Table of MCS index (IMCS) and its TBS index (ITBS). Taken from 3GPP TS
  * 36.213 v8.8.0 Table 8.6.1-1: _Modulation, TBS index and redundancy version table for PUSCH_.
  * The index of the vector (range 0-28) identifies the MCS index.
  */
-static const int McsToItbsUl[29] = {0,  1,  2,  3,  4,  5,  6,  7,  8,  9,  10, 10, 11, 12, 13,
-                                    14, 15, 16, 17, 18, 19, 19, 20, 21, 22, 23, 24, 25, 26};
+static const int McsToItbsUl[29] = {
+    0,  1,  2,  3,  4,  5,  6,  7,  8,  9,  10, 10, 11, 12, 13,
+    14, 15, 16, 17, 18, 19, 19, 20, 21, 22, 23, 24, 25, 26,
+};
 
 /**
  * Table of number of physical resource blocks (NPRB), TBS index (ITBS), and
@@ -444,8 +451,7 @@
                    43816, 46888, 51024, 55056, 59256, 61664, 66592, 68808, 75376},
     /* NPRB 110*/ {3112,  4008,  4968,  6456,  7992,  9528,  11448, 13536, 15264,
                    17568, 19080, 22152, 25456, 28336, 31704, 34008, 35160, 39232,
-                   43816, 46888, 51024, 55056, 59256, 63776, 66592, 71112, 75376}
-
+                   43816, 46888, 51024, 55056, 59256, 63776, 66592, 71112, 75376},
 };
 
 LteAmc::LteAmc()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/lte-as-sap.h ns-3.38/src/lte/model/lte-as-sap.h
--- ns-3.37/src/lte/model/lte-as-sap.h	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/lte-as-sap.h	2023-03-16 20:54:23.772869000 -0700
@@ -137,6 +137,9 @@
      */
     MemberLteAsSapProvider(C* owner);
 
+    // Delete default constructor to avoid misuse
+    MemberLteAsSapProvider() = delete;
+
     // inherited from LteAsSapProvider
     void SetCsgWhiteList(uint32_t csgId) override;
     void StartCellSelection(uint32_t dlEarfcn) override;
@@ -146,7 +149,6 @@
     void Disconnect() override;
 
   private:
-    MemberLteAsSapProvider();
     C* m_owner; ///< the owner class
 };
 
@@ -157,11 +159,6 @@
 }
 
 template <class C>
-MemberLteAsSapProvider<C>::MemberLteAsSapProvider()
-{
-}
-
-template <class C>
 void
 MemberLteAsSapProvider<C>::SetCsgWhiteList(uint32_t csgId)
 {
@@ -218,6 +215,9 @@
      */
     MemberLteAsSapUser(C* owner);
 
+    // Delete default constructor to avoid misuse
+    MemberLteAsSapUser() = delete;
+
     // inherited from LteAsSapUser
     void NotifyConnectionSuccessful() override;
     void NotifyConnectionFailed() override;
@@ -225,7 +225,6 @@
     void NotifyConnectionReleased() override;
 
   private:
-    MemberLteAsSapUser();
     C* m_owner; ///< the owner class
 };
 
@@ -235,11 +234,6 @@
 {
 }
 
-template <class C>
-MemberLteAsSapUser<C>::MemberLteAsSapUser()
-{
-}
-
 template <class C>
 void
 MemberLteAsSapUser<C>::NotifyConnectionSuccessful()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/lte-ccm-rrc-sap.h ns-3.38/src/lte/model/lte-ccm-rrc-sap.h
--- ns-3.37/src/lte/model/lte-ccm-rrc-sap.h	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/lte-ccm-rrc-sap.h	2023-03-16 20:54:23.772869000 -0700
@@ -105,7 +105,7 @@
      * \param lcid the Logical Channel id
      * \param lcGroup the Logical Channel group
      * \param msu a pointer to the LteMacSapUser, the LteEnbComponentCarrierManager
-     *             has to store a LteMacSapUser for each Rlc istance, in order to
+     *             has to store a LteMacSapUser for each Rlc instance, in order to
      *             properly redirect the packet
      * \return vector of LcsConfig contains the lc configuration for each Mac
      *                the size of the vector is equal to the number of component
@@ -136,7 +136,7 @@
     /**
      * \brief Add the Signal Bearer for a specific Ue in LteEnbComponenCarrierManager
      * \param lcInfo this structure it is hard-coded in the LteEnbRrc
-     * \param rlcMacSapUser it is the MacSapUser of the Rlc istance
+     * \param rlcMacSapUser it is the MacSapUser of the Rlc instance
      * \return the LteMacSapUser of the ComponentCarrierManager
      *
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/lte-common.cc ns-3.38/src/lte/model/lte-common.cc
--- ns-3.37/src/lte/model/lte-common.cc	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/lte-common.cc	2023-03-16 20:54:23.772869000 -0700
@@ -75,7 +75,7 @@
 }
 
 /**
- * Equaity operator
+ * Equality operator
  *
  * \param a lhs
  * \param b rhs
@@ -165,13 +165,11 @@
 
 /// Buffer size level BSR table
 static const uint32_t BufferSizeLevelBsrTable[64] = {
-
-    0,     10,    12,    14,    17,    19,    22,    26,    31,     36,     42,     49,    57,
-    67,    78,    91,    107,   125,   146,   171,   200,   234,    274,    321,    376,   440,
-    515,   603,   706,   826,   967,   1132,  1326,  1552,  1817,   2127,   2490,   2915,  3413,
-    3995,  4677,  5476,  6411,  7505,  8787,  10287, 12043, 14099,  16507,  19325,  22624, 26487,
-    31009, 36304, 42502, 49759, 58255, 68201, 79846, 93749, 109439, 128125, 150000, 150000
-
+    0,     10,    12,    14,    17,    19,    22,    26,    31,     36,     42,     49,     57,
+    67,    78,    91,    107,   125,   146,   171,   200,   234,    274,    321,    376,    440,
+    515,   603,   706,   826,   967,   1132,  1326,  1552,  1817,   2127,   2490,   2915,   3413,
+    3995,  4677,  5476,  6411,  7505,  8787,  10287, 12043, 14099,  16507,  19325,  22624,  26487,
+    31009, 36304, 42502, 49759, 58255, 68201, 79846, 93749, 109439, 128125, 150000, 150000,
 };
 
 uint32_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/lte-control-messages.cc ns-3.38/src/lte/model/lte-control-messages.cc
--- ns-3.37/src/lte/model/lte-control-messages.cc	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/lte-control-messages.cc	2023-03-16 20:54:23.772869000 -0700
@@ -69,7 +69,7 @@
     m_dci = dci;
 }
 
-DlDciListElement_s
+const DlDciListElement_s&
 DlDciLteControlMessage::GetDci()
 {
     return m_dci;
@@ -92,7 +92,7 @@
     m_dci = dci;
 }
 
-UlDciListElement_s
+const UlDciListElement_s&
 UlDciLteControlMessage::GetDci()
 {
     return m_dci;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/lte-control-messages.h ns-3.38/src/lte/model/lte-control-messages.h
--- ns-3.37/src/lte/model/lte-control-messages.h	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/lte-control-messages.h	2023-03-16 20:54:23.772869000 -0700
@@ -106,7 +106,7 @@
      * \brief Get dic information
      * \return dci messages
      */
-    DlDciListElement_s GetDci();
+    const DlDciListElement_s& GetDci();
 
   private:
     DlDciListElement_s m_dci; ///< DCI
@@ -135,7 +135,7 @@
      * \brief Get dic information
      * \return dci messages
      */
-    UlDciListElement_s GetDci();
+    const UlDciListElement_s& GetDci();
 
   private:
     UlDciListElement_s m_dci; ///< DCI
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/lte-enb-cphy-sap.h ns-3.38/src/lte/model/lte-enb-cphy-sap.h
--- ns-3.37/src/lte/model/lte-enb-cphy-sap.h	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/lte-enb-cphy-sap.h	2023-03-16 20:54:23.772869000 -0700
@@ -158,6 +158,9 @@
      */
     MemberLteEnbCphySapProvider(C* owner);
 
+    // Delete default constructor to avoid misuse
+    MemberLteEnbCphySapProvider() = delete;
+
     // inherited from LteEnbCphySapProvider
     void SetCellId(uint16_t cellId) override;
     void SetBandwidth(uint16_t ulBandwidth, uint16_t dlBandwidth) override;
@@ -172,7 +175,6 @@
     int8_t GetReferenceSignalPower() override;
 
   private:
-    MemberLteEnbCphySapProvider();
     C* m_owner; ///< the owner class
 };
 
@@ -183,11 +185,6 @@
 }
 
 template <class C>
-MemberLteEnbCphySapProvider<C>::MemberLteEnbCphySapProvider()
-{
-}
-
-template <class C>
 void
 MemberLteEnbCphySapProvider<C>::SetCellId(uint16_t cellId)
 {
@@ -280,10 +277,12 @@
      */
     MemberLteEnbCphySapUser(C* owner);
 
+    // Delete default constructor to avoid misuse
+    MemberLteEnbCphySapUser() = delete;
+
     // methods inherited from LteEnbCphySapUser go here
 
   private:
-    MemberLteEnbCphySapUser();
     C* m_owner; ///< the owner class
 };
 
@@ -293,11 +292,6 @@
 {
 }
 
-template <class C>
-MemberLteEnbCphySapUser<C>::MemberLteEnbCphySapUser()
-{
-}
-
 } // namespace ns3
 
 #endif // LTE_ENB_CPHY_SAP_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/lte-enb-mac.cc ns-3.38/src/lte/model/lte-enb-mac.cc
--- ns-3.37/src/lte/model/lte-enb-mac.cc	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/lte-enb-mac.cc	2023-03-16 20:54:23.772869000 -0700
@@ -490,7 +490,7 @@
 
     // --- DOWNLINK ---
     // Send Dl-CQI info to the scheduler
-    if (m_dlCqiReceived.size() > 0)
+    if (!m_dlCqiReceived.empty())
     {
         FfMacSchedSapProvider::SchedDlCqiInfoReqParameters dlcqiInfoReq;
         dlcqiInfoReq.m_sfnSf = ((0x3FF & frameNo) << 4) | (0xF & subframeNo);
@@ -564,7 +564,7 @@
     dlparams.m_sfnSf = ((0x3FF & dlSchedFrameNo) << 4) | (0xF & dlSchedSubframeNo);
 
     // Forward DL HARQ feebacks collected during last TTI
-    if (m_dlInfoListReceived.size() > 0)
+    if (!m_dlInfoListReceived.empty())
     {
         dlparams.m_dlInfoList = m_dlInfoListReceived;
         // empty local buffer
@@ -590,7 +590,7 @@
     m_ulCqiReceived.clear();
 
     // Send BSR reports to the scheduler
-    if (m_ulCeReceived.size() > 0)
+    if (!m_ulCeReceived.empty())
     {
         FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters ulMacReq;
         ulMacReq.m_sfnSf = ((0x3FF & frameNo) << 4) | (0xF & subframeNo);
@@ -618,7 +618,7 @@
     ulparams.m_sfnSf = ((0x3FF & ulSchedFrameNo) << 4) | (0xF & ulSchedSubframeNo);
 
     // Forward DL HARQ feebacks collected during last TTI
-    if (m_ulInfoListReceived.size() > 0)
+    if (!m_ulInfoListReceived.empty())
     {
         ulparams.m_ulInfoList = m_ulInfoListReceived;
         // empty local buffer
@@ -950,7 +950,7 @@
 }
 
 LteEnbCmacSapProvider::RachConfig
-LteEnbMac::DoGetRachConfig()
+LteEnbMac::DoGetRachConfig() const
 {
     struct LteEnbCmacSapProvider::RachConfig rc;
     rc.numberOfRaPreambles = m_numberOfRaPreambles;
@@ -1209,7 +1209,7 @@
         NS_LOG_INFO(this << " Send RAR message to RNTI " << ind.m_buildRarList.at(i).m_rnti
                          << " rapId " << itRapId->second);
     }
-    if (ind.m_buildRarList.size() > 0)
+    if (!ind.m_buildRarList.empty())
     {
         m_enbPhySapProvider->SendLteControlMessage(rarMsg);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/lte-enb-mac.h ns-3.38/src/lte/model/lte-enb-mac.h
--- ns-3.37/src/lte/model/lte-enb-mac.h	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/lte-enb-mac.h	2023-03-16 20:54:23.772869000 -0700
@@ -253,7 +253,7 @@
      * \brief Get RACH configuration function
      * \returns LteEnbCmacSapProvider::RachConfig
      */
-    LteEnbCmacSapProvider::RachConfig DoGetRachConfig();
+    LteEnbCmacSapProvider::RachConfig DoGetRachConfig() const;
     /**
      * \brief Allocate NC RA preamble function
      * \param rnti the RNTI
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/lte-enb-phy.cc ns-3.38/src/lte/model/lte-enb-phy.cc
--- ns-3.37/src/lte/model/lte-enb-phy.cc	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/lte-enb-phy.cc	2023-03-16 20:54:23.772869000 -0700
@@ -677,7 +677,7 @@
     std::list<Ptr<LteControlMessage>> ctrlMsg = GetControlMessages();
     m_dlDataRbMap.clear();
     m_dlPowerAllocationMap.clear();
-    if (ctrlMsg.size() > 0)
+    if (!ctrlMsg.empty())
     {
         std::list<Ptr<LteControlMessage>>::iterator it;
         it = ctrlMsg.begin();
@@ -706,7 +706,7 @@
                     mask = (mask << 1);
                 }
                 // fire trace of DL Tx PHY stats
-                for (uint8_t i = 0; i < dci->GetDci().m_mcs.size(); i++)
+                for (std::size_t i = 0; i < dci->GetDci().m_mcs.size(); i++)
                 {
                     PhyTransmissionStatParameters params;
                     params.m_cellId = m_cellId;
@@ -897,11 +897,11 @@
     m_dlBandwidth = dlBandwidth;
 
     static const int Type0AllocationRbg[4] = {
-        10, // RGB size 1
-        26, // RGB size 2
-        63, // RGB size 3
-        110 // RGB size 4
-    };      // see table 7.1.6.1-1 of 36.213
+        10,  // RGB size 1
+        26,  // RGB size 2
+        63,  // RGB size 3
+        110, // RGB size 4
+    };       // see table 7.1.6.1-1 of 36.213
     for (int i = 0; i < 4; i++)
     {
         if (dlBandwidth < Type0AllocationRbg[i])
@@ -1086,7 +1086,7 @@
 LteEnbPhy::DequeueUlDci()
 {
     NS_LOG_FUNCTION(this);
-    if (m_ulDciQueue.at(0).size() > 0)
+    if (!m_ulDciQueue.at(0).empty())
     {
         std::list<UlDciLteControlMessage> ret = m_ulDciQueue.at(0);
         m_ulDciQueue.erase(m_ulDciQueue.begin());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/lte-enb-phy-sap.h ns-3.38/src/lte/model/lte-enb-phy-sap.h
--- ns-3.37/src/lte/model/lte-enb-phy-sap.h	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/lte-enb-phy-sap.h	2023-03-16 20:54:23.772869000 -0700
@@ -105,14 +105,14 @@
     virtual void UlCqiReport(FfMacSchedSapProvider::SchedUlCqiInfoReqParameters ulcqi) = 0;
 
     /**
-     * Notify the HARQ on the UL tranmission status
+     * Notify the HARQ on the UL transmission status
      *
      * \param params
      */
     virtual void UlInfoListElementHarqFeeback(UlInfoListElement_s params) = 0;
 
     /**
-     * Notify the HARQ on the DL tranmission status
+     * Notify the HARQ on the DL transmission status
      *
      * \param params
      */
